Index: squid/lib/dlmalloc.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/lib/dlmalloc.c,v
retrieving revision 1.1.1.1.44.2
retrieving revision 1.1.1.1.44.2.2.1
diff -u -r1.1.1.1.44.2 -r1.1.1.1.44.2.2.1
--- squid/lib/dlmalloc.c	14 Jun 2001 21:34:24 -0000	1.1.1.1.44.2
+++ squid/lib/dlmalloc.c	27 Aug 2001 21:48:17 -0000	1.1.1.1.44.2.2.1
@@ -2420,204 +2381,197 @@
 
 
 #if __STD_C
-Void_t* rEALLOc(Void_t* oldmem, size_t bytes)
+Void_t *rEALLOc(Void_t * oldmem, size_t bytes)
 #else
-Void_t* rEALLOc(oldmem, bytes) Void_t* oldmem; size_t bytes;
+Void_t *rEALLOc(oldmem, bytes)
+     Void_t *oldmem;
+     size_t bytes;
 #endif
 {
-  INTERNAL_SIZE_T    nb;      /* padded request size */
+    INTERNAL_SIZE_T nb;		/* padded request size */
 
-  mchunkptr oldp;             /* chunk corresponding to oldmem */
-  INTERNAL_SIZE_T    oldsize; /* its size */
+    mchunkptr oldp;		/* chunk corresponding to oldmem */
+    INTERNAL_SIZE_T oldsize;	/* its size */
 
-  mchunkptr newp;             /* chunk to return */
-  INTERNAL_SIZE_T    newsize; /* its size */
-  Void_t*   newmem;           /* corresponding user mem */
+    mchunkptr newp;		/* chunk to return */
+    INTERNAL_SIZE_T newsize;	/* its size */
+    Void_t *newmem;		/* corresponding user mem */
 
-  mchunkptr next;             /* next contiguous chunk after oldp */
-  INTERNAL_SIZE_T  nextsize;  /* its size */
+    mchunkptr next;		/* next contiguous chunk after oldp */
+    INTERNAL_SIZE_T nextsize;	/* its size */
 
-  mchunkptr prev;             /* previous contiguous chunk before oldp */
-  INTERNAL_SIZE_T  prevsize;  /* its size */
+    mchunkptr prev;		/* previous contiguous chunk before oldp */
+    INTERNAL_SIZE_T prevsize;	/* its size */
 
-  mchunkptr remainder;        /* holds split off extra space from newp */
-  INTERNAL_SIZE_T  remainder_size;   /* its size */
+    mchunkptr remainder;	/* holds split off extra space from newp */
+    INTERNAL_SIZE_T remainder_size;	/* its size */
 
-  mchunkptr bck;              /* misc temp for linking */
-  mchunkptr fwd;              /* misc temp for linking */
+    mchunkptr bck;		/* misc temp for linking */
+    mchunkptr fwd;		/* misc temp for linking */
 
 #ifdef REALLOC_ZERO_BYTES_FREES
-  if (bytes == 0) { fREe(oldmem); return 0; }
+    if (bytes == 0) {
+	fREe(oldmem);
+	return 0;
+    }
 #endif
 
 
-  /* realloc of null is supposed to be same as malloc */
-  if (oldmem == 0) return mALLOc(bytes);
+    /* realloc of null is supposed to be same as malloc */
+    if (oldmem == 0)
+	return mALLOc(bytes);
 
-  newp    = oldp    = mem2chunk(oldmem);
-  newsize = oldsize = chunksize(oldp);
+    newp = oldp = mem2chunk(oldmem);
+    newsize = oldsize = chunksize(oldp);
 
 
-  nb = request2size(bytes);
+    nb = request2size(bytes);
 
 #if HAVE_MMAP
-  if (chunk_is_mmapped(oldp)) 
-  {
+    if (chunk_is_mmapped(oldp)) {
 #if HAVE_MREMAP
-    newp = mremap_chunk(oldp, nb);
-    if(newp) return chunk2mem(newp);
-#endif
-    /* Note the extra SIZE_SZ overhead. */
-    if(oldsize - SIZE_SZ >= nb) return oldmem; /* do nothing */
-    /* Must alloc, copy, free. */
-    newmem = mALLOc(bytes);
-    if (newmem == 0) return 0; /* propagate failure */
-    MALLOC_COPY(newmem, oldmem, oldsize - 2*SIZE_SZ);
-    munmap_chunk(oldp);
-    return newmem;
-  }
+	newp = mremap_chunk(oldp, nb);
+	if (newp)
+	    return chunk2mem(newp);
+#endif
+	/* Note the extra SIZE_SZ overhead. */
+	if (oldsize - SIZE_SZ >= nb)
+	    return oldmem;	/* do nothing */
+	/* Must alloc, copy, free. */
+	newmem = mALLOc(bytes);
+	if (newmem == 0)
+	    return 0;		/* propagate failure */
+	MALLOC_COPY(newmem, oldmem, oldsize - 2 * SIZE_SZ);
+	munmap_chunk(oldp);
+	return newmem;
+    }
 #endif
 
-  check_inuse_chunk(oldp);
+    check_inuse_chunk(oldp);
 
-  if ((long)(oldsize) < (long)(nb))  
-  {
+    if ((long) (oldsize) < (long) (nb)) {
 
-    /* Try expanding forward */
+	/* Try expanding forward */
 
-    next = chunk_at_offset(oldp, oldsize);
-    if (next == top || !inuse(next)) 
-    {
-      nextsize = chunksize(next);
+	next = chunk_at_offset(oldp, oldsize);
+	if (next == top || !inuse(next)) {
+	    nextsize = chunksize(next);
+
+	    /* Forward into top only if a remainder */
+	    if (next == top) {
+		if ((long) (nextsize + newsize) >= (long) (nb + MINSIZE)) {
+		    newsize += nextsize;
+		    top = chunk_at_offset(oldp, nb);
+		    set_head(top, (newsize - nb) | PREV_INUSE);
+		    set_head_size(oldp, nb);
+		    return chunk2mem(oldp);
+		}
+	    }
 
-      /* Forward into top only if a remainder */
-      if (next == top)
-      {
-        if ((long)(nextsize + newsize) >= (long)(nb + MINSIZE))
-        {
-          newsize += nextsize;
-          top = chunk_at_offset(oldp, nb);
-          set_head(top, (newsize - nb) | PREV_INUSE);
-          set_head_size(oldp, nb);
-          return chunk2mem(oldp);
-        }
-      }
-
-      /* Forward into next chunk */
-      else if (((long)(nextsize + newsize) >= (long)(nb)))
-      { 
-        unlink(next, bck, fwd);
-        newsize  += nextsize;
-        goto split;
-      }
-    }
-    else
-    {
-      next = 0;
-      nextsize = 0;
-    }
+	    /* Forward into next chunk */
+	    else if (((long) (nextsize + newsize) >= (long) (nb))) {
+		unlink(next, bck, fwd);
+		newsize += nextsize;
+		goto split;
+	    }
+	} else {
+	    next = 0;
+	    nextsize = 0;
+	}
 
-    /* Try shifting backwards. */
+	/* Try shifting backwards. */
 
-    if (!prev_inuse(oldp))
-    {
-      prev = prev_chunk(oldp);
-      prevsize = chunksize(prev);
+	if (!prev_inuse(oldp)) {
+	    prev = prev_chunk(oldp);
+	    prevsize = chunksize(prev);
+
+	    /* try forward + backward first to save a later consolidation */
+
+	    if (next != 0) {
+		/* into top */
+		if (next == top) {
+		    if ((long) (nextsize + prevsize + newsize) >=
+			(long) (nb + MINSIZE)) {
+			unlink(prev, bck, fwd);
+			newp = prev;
+			newsize += prevsize + nextsize;
+			newmem = chunk2mem(newp);
+			MALLOC_COPY(newmem, oldmem, oldsize - SIZE_SZ);
+			top = chunk_at_offset(newp, nb);
+			set_head(top, (newsize - nb) | PREV_INUSE);
+			set_head_size(newp, nb);
+			return newmem;
+		    }
+		}
 
-      /* try forward + backward first to save a later consolidation */
+		/* into next chunk */
+		else if (((long) (nextsize + prevsize + newsize) >=
+			(long) (nb))) {
+		    unlink(next, bck, fwd);
+		    unlink(prev, bck, fwd);
+		    newp = prev;
+		    newsize += nextsize + prevsize;
+		    newmem = chunk2mem(newp);
+		    MALLOC_COPY(newmem, oldmem, oldsize - SIZE_SZ);
+		    goto split;
+		}
+	    }
 
-      if (next != 0)
-      {
-        /* into top */
-        if (next == top)
-        {
-          if ((long)(nextsize + prevsize + newsize) >= (long)(nb + MINSIZE))
-          {
-            unlink(prev, bck, fwd);
-            newp = prev;
-            newsize += prevsize + nextsize;
-            newmem = chunk2mem(newp);
-            MALLOC_COPY(newmem, oldmem, oldsize - SIZE_SZ);
-            top = chunk_at_offset(newp, nb);
-            set_head(top, (newsize - nb) | PREV_INUSE);
-            set_head_size(newp, nb);
-            return newmem;
-          }
-        }
-
-        /* into next chunk */
-        else if (((long)(nextsize + prevsize + newsize) >= (long)(nb)))
-        {
-          unlink(next, bck, fwd);
-          unlink(prev, bck, fwd);
-          newp = prev;
-          newsize += nextsize + prevsize;
-          newmem = chunk2mem(newp);
-          MALLOC_COPY(newmem, oldmem, oldsize - SIZE_SZ);
-          goto split;
-        }
-      }
-      
-      /* backward only */
-      if (prev != 0 && (long)(prevsize + newsize) >= (long)nb)  
-      {
-        unlink(prev, bck, fwd);
-        newp = prev;
-        newsize += prevsize;
-        newmem = chunk2mem(newp);
-        MALLOC_COPY(newmem, oldmem, oldsize - SIZE_SZ);
-        goto split;
-      }
-    }
-
-    /* Must allocate */
-
-    newmem = mALLOc (bytes);
+	    /* backward only */
+	    if (prev != 0 && (long) (prevsize + newsize) >= (long) nb) {
+		unlink(prev, bck, fwd);
+		newp = prev;
+		newsize += prevsize;
+		newmem = chunk2mem(newp);
+		MALLOC_COPY(newmem, oldmem, oldsize - SIZE_SZ);
+		goto split;
+	    }
+	}
 
-    if (newmem == 0)  /* propagate failure */
-      return 0; 
+	/* Must allocate */
 
-    /* Avoid copy if newp is next chunk after oldp. */
-    /* (This can only happen when new chunk is sbrk'ed.) */
+	newmem = mALLOc(bytes);
 
-    if ( (newp = mem2chunk(newmem)) == next_chunk(oldp)) 
-    {
-      newsize += chunksize(newp);
-      newp = oldp;
-      goto split;
-    }
-
-    /* Otherwise copy, free, and exit */
-    MALLOC_COPY(newmem, oldmem, oldsize - SIZE_SZ);
-    fREe(oldmem);
-    return newmem;
-  }
-
-
- split:  /* split off extra room in old or expanded chunk */
-
-  if (newsize - nb >= MINSIZE) /* split off remainder */
-  {
-    remainder = chunk_at_offset(newp, nb);
-    remainder_size = newsize - nb;
-    set_head_size(newp, nb);
-    set_head(remainder, remainder_size | PREV_INUSE);
-    set_inuse_bit_at_offset(remainder, remainder_size);
-    fREe(chunk2mem(remainder)); /* let free() deal with it */
-  }
-  else
-  {
-    set_head_size(newp, newsize);
-    set_inuse_bit_at_offset(newp, newsize);
-  }
+	if (newmem == 0)	/* propagate failure */
+	    return 0;
 
-  check_inuse_chunk(newp);
-  return chunk2mem(newp);
-}
+	/* Avoid copy if newp is next chunk after oldp. */
+	/* (This can only happen when new chunk is sbrk'ed.) */
+
+	if ((newp = mem2chunk(newmem)) == next_chunk(oldp)) {
+	    newsize += chunksize(newp);
+	    newp = oldp;
+	    goto split;
+	}
+
+	/* Otherwise copy, free, and exit */
+	MALLOC_COPY(newmem, oldmem, oldsize - SIZE_SZ);
+	fREe(oldmem);
+	return newmem;
+    }
 
 
+  split:			/* split off extra room in old or expanded chunk */
+
+    if (newsize - nb >= MINSIZE) {	/* split off remainder */
+	remainder = chunk_at_offset(newp, nb);
+	remainder_size = newsize - nb;
+	set_head_size(newp, nb);
+	set_head(remainder, remainder_size | PREV_INUSE);
+	set_inuse_bit_at_offset(remainder, remainder_size);
+	fREe(chunk2mem(remainder));	/* let free() deal with it */
+    } else {
+	set_head_size(newp, newsize);
+	set_inuse_bit_at_offset(newp, newsize);
+    }
+
+    check_inuse_chunk(newp);
+    return chunk2mem(newp);
+}
 
 
+
+
 /*
 
   memalign algorithm:
@@ -2638,103 +2592,108 @@
 
 
 #if __STD_C
-Void_t* mEMALIGn(size_t alignment, size_t bytes)
+Void_t *mEMALIGn(size_t alignment, size_t bytes)
 #else
-Void_t* mEMALIGn(alignment, bytes) size_t alignment; size_t bytes;
+Void_t *mEMALIGn(alignment, bytes)
+     size_t alignment;
+     size_t bytes;
 #endif
 {
-  INTERNAL_SIZE_T    nb;      /* padded  request size */
-  char*     m;                /* memory returned by malloc call */
-  mchunkptr p;                /* corresponding chunk */
-  char*     brk;              /* alignment point within p */
-  mchunkptr newp;             /* chunk to return */
-  INTERNAL_SIZE_T  newsize;   /* its size */
-  INTERNAL_SIZE_T  leadsize;  /* leading space befor alignment point */
-  mchunkptr remainder;        /* spare room at end to split off */
-  long      remainder_size;   /* its size */
+    INTERNAL_SIZE_T nb;		/* padded  request size */
+    char *m;			/* memory returned by malloc call */
+    mchunkptr p;		/* corresponding chunk */
+    char *brk;			/* alignment point within p */
+    mchunkptr newp;		/* chunk to return */
+    INTERNAL_SIZE_T newsize;	/* its size */
+    INTERNAL_SIZE_T leadsize;	/* leading space befor alignment point */
+    mchunkptr remainder;	/* spare room at end to split off */
+    long remainder_size;	/* its size */
 
-  /* If need less alignment than we give anyway, just relay to malloc */
+    /* If need less alignment than we give anyway, just relay to malloc */
 
-  if (alignment <= MALLOC_ALIGNMENT) return mALLOc(bytes);
+    if (alignment <= MALLOC_ALIGNMENT)
+	return mALLOc(bytes);
 
-  /* Otherwise, ensure that it is at least a minimum chunk size */
-  
-  if (alignment <  MINSIZE) alignment = MINSIZE;
+    /* Otherwise, ensure that it is at least a minimum chunk size */
+
+    if (alignment < MINSIZE)
+	alignment = MINSIZE;
 
-  /* Call malloc with worst case padding to hit alignment. */
+    /* Call malloc with worst case padding to hit alignment. */
 
-  nb = request2size(bytes);
-  m  = (char*)(mALLOc(nb + alignment + MINSIZE));
+    nb = request2size(bytes);
+    m = (char *) (mALLOc(nb + alignment + MINSIZE));
 
-  if (m == 0) return 0; /* propagate failure */
+    if (m == 0)
+	return 0;		/* propagate failure */
 
-  p = mem2chunk(m);
+    p = mem2chunk(m);
 
-  if ((((unsigned long)(m)) % alignment) == 0) /* aligned */
-  {
+    if ((((unsigned long) (m)) % alignment) == 0) {	/* aligned */
 #if HAVE_MMAP
-    if(chunk_is_mmapped(p))
-      return chunk2mem(p); /* nothing more to do */
+	if (chunk_is_mmapped(p))
+	    return chunk2mem(p);	/* nothing more to do */
 #endif
-  }
-  else /* misaligned */
-  {
-    /* 
-      Find an aligned spot inside chunk.
-      Since we need to give back leading space in a chunk of at 
-      least MINSIZE, if the first calculation places us at
-      a spot with less than MINSIZE leader, we can move to the
-      next aligned spot -- we've allocated enough total room so that
-      this is always possible.
-    */
-
-    brk = (char*)mem2chunk(((unsigned long)(m + alignment - 1)) & -alignment);
-    if ((long)(brk - (char*)(p)) < MINSIZE) brk = brk + alignment;
-
-    newp = (mchunkptr)brk;
-    leadsize = brk - (char*)(p);
-    newsize = chunksize(p) - leadsize;
+    } else {			/* misaligned */
+
+	/* 
+	 * Find an aligned spot inside chunk.
+	 * Since we need to give back leading space in a chunk of at 
+	 * least MINSIZE, if the first calculation places us at
+	 * a spot with less than MINSIZE leader, we can move to the
+	 * next aligned spot -- we've allocated enough total room so that
+	 * this is always possible.
+	 */
+
+	brk =
+	    (char *) mem2chunk(((unsigned long) (m + alignment -
+		  1)) & -alignment);
+	if ((long) (brk - (char *) (p)) < MINSIZE)
+	    brk = brk + alignment;
+
+	newp = (mchunkptr) brk;
+	leadsize = brk - (char *) (p);
+	newsize = chunksize(p) - leadsize;
 
 #if HAVE_MMAP
-    if(chunk_is_mmapped(p)) 
-    {
-      newp->prev_size = p->prev_size + leadsize;
-      set_head(newp, newsize|IS_MMAPPED);
-      return chunk2mem(newp);
-    }
+	if (chunk_is_mmapped(p)) {
+	    newp->prev_size = p->prev_size + leadsize;
+	    set_head(newp, newsize | IS_MMAPPED);
+	    return chunk2mem(newp);
+	}
 #endif
 
-    /* give back leader, use the rest */
+	/* give back leader, use the rest */
 
-    set_head(newp, newsize | PREV_INUSE);
-    set_inuse_bit_at_offset(newp, newsize);
-    set_head_size(p, leadsize);
-    fREe(chunk2mem(p));
-    p = newp;
+	set_head(newp, newsize | PREV_INUSE);
+	set_inuse_bit_at_offset(newp, newsize);
+	set_head_size(p, leadsize);
+	fREe(chunk2mem(p));
+	p = newp;
 
-    assert (newsize >= nb && (((unsigned long)(chunk2mem(p))) % alignment) == 0);
-  }
+	assert(newsize >= nb
+	    && (((unsigned long) (chunk2mem(p))) % alignment) == 0);
+    }
 
-  /* Also give back spare room at the end */
+    /* Also give back spare room at the end */
 
-  remainder_size = chunksize(p) - nb;
+    remainder_size = chunksize(p) - nb;
 
-  if (remainder_size >= (long)MINSIZE)
-  {
-    remainder = chunk_at_offset(p, nb);
-    set_head(remainder, remainder_size | PREV_INUSE);
-    set_head_size(p, nb);
-    fREe(chunk2mem(remainder));
-  }
+    if (remainder_size >= (long) MINSIZE) {
+	remainder = chunk_at_offset(p, nb);
+	set_head(remainder, remainder_size | PREV_INUSE);
+	set_head_size(p, nb);
+	fREe(chunk2mem(remainder));
+    }
 
-  check_inuse_chunk(p);
-  return chunk2mem(p);
+    check_inuse_chunk(p);
+    return chunk2mem(p);
 
 }
-
 
 
 
+
 /*
     valloc just invokes memalign with alignment argument equal
     to the page size of the system (or as near to this as can
@@ -2742,12 +2701,13 @@
 */
 
 #if __STD_C
-Void_t* vALLOc(size_t bytes)
+Void_t *vALLOc(size_t bytes)
 #else
-Void_t* vALLOc(bytes) size_t bytes;
+Void_t *vALLOc(bytes)
+     size_t bytes;
 #endif
 {
-  return mEMALIGn (malloc_getpagesize, bytes);
+    return mEMALIGn(malloc_getpagesize, bytes);
 }
 
 /* 
@@ -2757,13 +2717,14 @@
 
 
 #if __STD_C
-Void_t* pvALLOc(size_t bytes)
+Void_t *pvALLOc(size_t bytes)
 #else
-Void_t* pvALLOc(bytes) size_t bytes;
+Void_t *pvALLOc(bytes)
+     size_t bytes;
 #endif
 {
-  size_t pagesize = malloc_getpagesize;
-  return mEMALIGn (pagesize, (bytes + pagesize - 1) & ~(pagesize - 1));
+    size_t pagesize = malloc_getpagesize;
+    return mEMALIGn(pagesize, (bytes + pagesize - 1) & ~(pagesize - 1));
 }
 
 /*
@@ -2773,49 +2734,50 @@
 */
 
 #if __STD_C
-Void_t* cALLOc(size_t n, size_t elem_size)
+Void_t *cALLOc(size_t n, size_t elem_size)
 #else
-Void_t* cALLOc(n, elem_size) size_t n; size_t elem_size;
+Void_t *cALLOc(n, elem_size)
+     size_t n;
+     size_t elem_size;
 #endif
 {
-  mchunkptr p;
-  INTERNAL_SIZE_T csz;
+    mchunkptr p;
+    INTERNAL_SIZE_T csz;
 
-  INTERNAL_SIZE_T sz = n * elem_size;
+    INTERNAL_SIZE_T sz = n * elem_size;
 
-  /* check if expand_top called, in which case don't need to clear */
+    /* check if expand_top called, in which case don't need to clear */
 #if MORECORE_CLEARS
-  mchunkptr oldtop = top;
-  INTERNAL_SIZE_T oldtopsize = chunksize(top);
+    mchunkptr oldtop = top;
+    INTERNAL_SIZE_T oldtopsize = chunksize(top);
 #endif
-  Void_t* mem = mALLOc (sz);
+    Void_t *mem = mALLOc(sz);
 
-  if (mem == 0) 
-    return 0;
-  else
-  {
-    p = mem2chunk(mem);
+    if (mem == 0)
+	return 0;
+    else {
+	p = mem2chunk(mem);
 
-    /* Two optional cases in which clearing not necessary */
+	/* Two optional cases in which clearing not necessary */
 
 
 #if HAVE_MMAP
-    if (chunk_is_mmapped(p)) return mem;
+	if (chunk_is_mmapped(p))
+	    return mem;
 #endif
 
-    csz = chunksize(p);
+	csz = chunksize(p);
 
 #if MORECORE_CLEARS
-    if (p == oldtop && csz > oldtopsize) 
-    {
-      /* clear only the bytes from non-freshly-sbrked memory */
-      csz = oldtopsize;
-    }
+	if (p == oldtop && csz > oldtopsize) {
+	    /* clear only the bytes from non-freshly-sbrked memory */
+	    csz = oldtopsize;
+	}
 #endif
 
-    MALLOC_ZERO(mem, csz - SIZE_SZ);
-    return mem;
-  }
+	MALLOC_ZERO(mem, csz - SIZE_SZ);
+	return mem;
+    }
 }
 
 /*
@@ -2827,17 +2789,18 @@
 
 #if !defined(INTERNAL_LINUX_C_LIB) || !defined(__ELF__)
 #if __STD_C
-void cfree(Void_t *mem)
+void cfree(Void_t * mem)
 #else
-void cfree(mem) Void_t *mem;
+void cfree(mem)
+     Void_t *mem;
 #endif
 {
-  free(mem);
+    free(mem);
 }
 #endif
-
 
 
+
 /*
 
     Malloc_trim gives memory back to the system (via negative
@@ -2864,61 +2827,57 @@
 #if __STD_C
 int malloc_trim(size_t pad)
 #else
-int malloc_trim(pad) size_t pad;
+int malloc_trim(pad)
+     size_t pad;
 #endif
 {
-  long  top_size;        /* Amount of top-most memory */
-  long  extra;           /* Amount to release */
-  char* current_brk;     /* address returned by pre-check sbrk call */
-  char* new_brk;         /* address returned by negative sbrk call */
-
-  unsigned long pagesz = malloc_getpagesize;
-
-  top_size = chunksize(top);
-  extra = ((top_size - pad - MINSIZE + (pagesz-1)) / pagesz - 1) * pagesz;
-
-  if (extra < (long)pagesz)  /* Not enough memory to release */
-    return 0;
-
-  else
-  {
-    /* Test to make sure no one else called sbrk */
-    current_brk = (char*)(MORECORE (0));
-    if (current_brk != (char*)(top) + top_size)
-      return 0;     /* Apparently we don't own memory; must fail */
-
-    else
-    {
-      new_brk = (char*)(MORECORE (-extra));
-      
-      if (new_brk == (char*)(MORECORE_FAILURE)) /* sbrk failed? */
-      {
-        /* Try to figure out what we have */
-        current_brk = (char*)(MORECORE (0));
-        top_size = current_brk - (char*)top;
-        if (top_size >= (long)MINSIZE) /* if not, we are very very dead! */
-        {
-          sbrked_mem = current_brk - sbrk_base;
-          set_head(top, top_size | PREV_INUSE);
-        }
-        check_chunk(top);
-        return 0; 
-      }
-
-      else
-      {
-        /* Success. Adjust top accordingly. */
-        set_head(top, (top_size - extra) | PREV_INUSE);
-        sbrked_mem -= extra;
-        check_chunk(top);
-        return 1;
-      }
+    long top_size;		/* Amount of top-most memory */
+    long extra;			/* Amount to release */
+    char *current_brk;		/* address returned by pre-check sbrk call */
+    char *new_brk;		/* address returned by negative sbrk call */
+
+    unsigned long pagesz = malloc_getpagesize;
+
+    top_size = chunksize(top);
+    extra = ((top_size - pad - MINSIZE + (pagesz - 1)) / pagesz - 1) * pagesz;
+
+    if (extra < (long) pagesz)	/* Not enough memory to release */
+	return 0;
+
+    else {
+	/* Test to make sure no one else called sbrk */
+	current_brk = (char *) (MORECORE(0));
+	if (current_brk != (char *) (top) + top_size)
+	    return 0;		/* Apparently we don't own memory; must fail */
+
+	else {
+	    new_brk = (char *) (MORECORE(-extra));
+
+	    if (new_brk == (char *) (MORECORE_FAILURE)) {	/* sbrk failed? */
+		/* Try to figure out what we have */
+		current_brk = (char *) (MORECORE(0));
+		top_size = current_brk - (char *) top;
+		if (top_size >= (long) MINSIZE) {	/* if not, we are very very dead! */
+		    sbrked_mem = current_brk - sbrk_base;
+		    set_head(top, top_size | PREV_INUSE);
+		}
+		check_chunk(top);
+		return 0;
+	    }
+
+	    else {
+		/* Success. Adjust top accordingly. */
+		set_head(top, (top_size - extra) | PREV_INUSE);
+		sbrked_mem -= extra;
+		check_chunk(top);
+		return 1;
+	    }
+	}
     }
-  }
 }
-
 
 
+
 /*
   malloc_usable_size:
 
@@ -2931,72 +2890,70 @@
 */
 
 #if __STD_C
-size_t malloc_usable_size(Void_t* mem)
+size_t malloc_usable_size(Void_t * mem)
 #else
-size_t malloc_usable_size(mem) Void_t* mem;
+size_t malloc_usable_size(mem)
+     Void_t *mem;
 #endif
 {
-  mchunkptr p;
-  if (mem == 0)
-    return 0;
-  else
-  {
-    p = mem2chunk(mem);
-    if(!chunk_is_mmapped(p))
-    {
-      if (!inuse(p)) return 0;
-      check_inuse_chunk(p);
-      return chunksize(p) - SIZE_SZ;
+    mchunkptr p;
+    if (mem == 0)
+	return 0;
+    else {
+	p = mem2chunk(mem);
+	if (!chunk_is_mmapped(p)) {
+	    if (!inuse(p))
+		return 0;
+	    check_inuse_chunk(p);
+	    return chunksize(p) - SIZE_SZ;
+	}
+	return chunksize(p) - 2 * SIZE_SZ;
     }
-    return chunksize(p) - 2*SIZE_SZ;
-  }
 }
+
 
 
-
 
 /* Utility to update current_mallinfo for malloc_stats and mallinfo() */
 
-static void malloc_update_mallinfo() 
+static void malloc_update_mallinfo()
 {
-  int i;
-  mbinptr b;
-  mchunkptr p;
+    int i;
+    mbinptr b;
+    mchunkptr p;
 #if DEBUG
-  mchunkptr q;
+    mchunkptr q;
 #endif
 
-  INTERNAL_SIZE_T avail = chunksize(top);
-  int   navail = ((long)(avail) >= (long)MINSIZE)? 1 : 0;
+    INTERNAL_SIZE_T avail = chunksize(top);
+    int navail = ((long) (avail) >= (long) MINSIZE) ? 1 : 0;
 
-  for (i = 1; i < NAV; ++i)
-  {
-    b = bin_at(i);
-    for (p = last(b); p != b; p = p->bk) 
-    {
+    for (i = 1; i < NAV; ++i) {
+	b = bin_at(i);
+	for (p = last(b); p != b; p = p->bk) {
 #if DEBUG
-      check_free_chunk(p);
-      for (q = next_chunk(p); 
-           q < top && inuse(q) && (long)(chunksize(q)) >= (long)MINSIZE; 
-           q = next_chunk(q))
-        check_inuse_chunk(q);
-#endif
-      avail += chunksize(p);
-      navail++;
-    }
-  }
-
-  current_mallinfo.ordblks = navail;
-  current_mallinfo.uordblks = sbrked_mem - avail;
-  current_mallinfo.fordblks = avail;
-  current_mallinfo.hblks = n_mmaps;
-  current_mallinfo.hblkhd = mmapped_mem;
-  current_mallinfo.keepcost = chunksize(top);
+	    check_free_chunk(p);
+	    for (q = next_chunk(p);
+		q < top && inuse(q) && (long) (chunksize(q)) >= (long) MINSIZE;
+		q = next_chunk(q))
+		check_inuse_chunk(q);
+#endif
+	    avail += chunksize(p);
+	    navail++;
+	}
+    }
 
-}
+    current_mallinfo.ordblks = navail;
+    current_mallinfo.uordblks = sbrked_mem - avail;
+    current_mallinfo.fordblks = avail;
+    current_mallinfo.hblks = n_mmaps;
+    current_mallinfo.hblkhd = mmapped_mem;
+    current_mallinfo.keepcost = chunksize(top);
 
+}
 
 
+
 /*
 
   malloc_stats:
@@ -3014,16 +2971,15 @@
 
 void malloc_stats()
 {
-  malloc_update_mallinfo();
-  fprintf(stderr, "max system bytes = %10u\n", 
-          (unsigned int)(max_total_mem));
-  fprintf(stderr, "system bytes     = %10u\n", 
-          (unsigned int)(sbrked_mem + mmapped_mem));
-  fprintf(stderr, "in use bytes     = %10u\n", 
-          (unsigned int)(current_mallinfo.uordblks + mmapped_mem));
+    malloc_update_mallinfo();
+    fprintf(stderr, "max system bytes = %10u\n",
+	(unsigned int) (max_total_mem));
+    fprintf(stderr, "system bytes     = %10u\n",
+	(unsigned int) (sbrked_mem + mmapped_mem));
+    fprintf(stderr, "in use bytes     = %10u\n",
+	(unsigned int) (current_mallinfo.uordblks + mmapped_mem));
 #if HAVE_MMAP
-  fprintf(stderr, "max mmap regions = %10u\n", 
-          (unsigned int)max_n_mmaps);
+    fprintf(stderr, "max mmap regions = %10u\n", (unsigned int) max_n_mmaps);
 #endif
 }
 
@@ -3033,12 +2989,12 @@
 
 struct mallinfo mALLINFo()
 {
-  malloc_update_mallinfo();
-  return current_mallinfo;
+    malloc_update_mallinfo();
+    return current_mallinfo;
 }
+
 
 
-
 
 /*
   mallopt:
@@ -3056,27 +3012,36 @@
 #if __STD_C
 int mALLOPt(int param_number, int value)
 #else
-int mALLOPt(param_number, value) int param_number; int value;
+int mALLOPt(param_number, value)
+     int param_number;
+     int value;
 #endif
 {
-  switch(param_number) 
-  {
+    switch (param_number) {
     case M_TRIM_THRESHOLD:
-      trim_threshold = value; return 1; 
+	trim_threshold = value;
+	return 1;
     case M_TOP_PAD:
-      top_pad = value; return 1; 
+	top_pad = value;
+	return 1;
     case M_MMAP_THRESHOLD:
-      mmap_threshold = value; return 1;
+	mmap_threshold = value;
+	return 1;
     case M_MMAP_MAX:
 #if HAVE_MMAP
-      n_mmaps_max = value; return 1;
+	n_mmaps_max = value;
+	return 1;
 #else
-      if (value != 0) return 0; else  n_mmaps_max = value; return 1;
+	if (value != 0)
+	    return 0;
+	else
+	    n_mmaps_max = value;
+	return 1;
 #endif
 
     default:
-      return 0;
-  }
+	return 0;
+    }
 }
 
 /*
@@ -3166,5 +3131,3 @@
          structure of old version,  but most details differ.)
 
 */
-
-
Index: squid/lib/drand48.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/lib/drand48.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.122.1
diff -u -r1.1.1.2 -r1.1.1.2.122.1
--- squid/lib/drand48.c	26 Jan 2000 03:25:00 -0000	1.1.1.2
+++ squid/lib/drand48.c	27 Aug 2001 21:48:18 -0000	1.1.1.2.122.1
@@ -1,5 +1,3 @@
-
-
 /* borrowed from libc/misc/drand48.c in Linux libc-5.4.46 this quick
  * hack by Martin Hamilton <martinh@gnu.org> to make Squid build on
  * Win32 with GNU-Win32 - sorry, folks! */
@@ -23,9 +21,11 @@
 #define C	0xB
 
 static void next(void);
-static unsigned x[3] =
-{X0, X1, X2}, a[3] =
-{A0, A1, A2}, c = C;
+static unsigned x[3] = { X0, X1, X2 }, a[3] =
+
+{
+A0, A1, A2}
+, c = C;
 
 double drand48(void);
 
